/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2017 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: tusbd_conf.h 698 2017-10-05 21:46:02Z roi $
 */
/*
 *  TOPPERS USB DEVICE MODULE CONFIGURATION 󥯥롼ɥե
 */

#ifndef _TUSBD_CONF_H_
#define _TUSBD_CONF_H_

#include "dwc2_device_driver.h"

#define TUSBD_MAX_NUM_INTERFACES              1
#define TUSBD_MAX_NUM_CONFIGURATION           1
#define TUSBD_NUM_ENDPOINT                    15
#define TUSBD_CONFIG_SELF_POWERED             0x01

#define USBD_StatusTypeDef   TUSBD_ERCODE
#define USBD_HandleTypeDef   TUSBD_Handle_t
#define USBD_Init            tusbdInit
#define USBD_Start           tusbdStart

extern uint8_t defaultDeviceDescriptor[];
extern uint8_t defaultDeviceQualifierDescriptor[];
extern uint8_t defaultLanguageIDDescriptor[];
extern uint8_t defaultManufacturerString[];
extern uint8_t defaultProductString[];
extern uint8_t defaultSerialString[];
extern uint8_t defaultConfigurationString[];
extern uint8_t defaultInterfaceString[];

#define TUSBD_DEVICE_DESCRIPTOR               defaultDeviceDescriptor
#define TUSBD_DEVICE_QUALIFIER_DESCRIPTOR     defaultDeviceQualifierDescriptor
#define TUSBD_LANGUAGEID_DESCRIPTOR           defaultLanguageIDDescriptor
#define TUSBD_MANUFACTURER_STRING             defaultManufacturerString
#define TUSBD_PRODUCT_STRING                  defaultProductString
#define TUSBD_SERIAL_STRING                   defaultSerialString
#define TUSBD_CONFIGURATION_STRING            defaultConfigurationString
#define TUSBD_INTERFACE_STRING                defaultInterfaceString
#define TUSBD_USER_STRING                     NULL

#define tusbdDriverSetUSBAddress(d, a)  usbo_setDevAddress(((d)->pSysData), (a))
#define tusbdDriverGetRxDataSize        dwc2_device_getrxdatasize

#define tusbdDriverInit                 dwc2_device_init
#define tusbdDriverDeInit               dwc2_device_deinit
#define tusbdDriverStart                dwc2_device_start
#define tusbdDriverStop                 dwc2_device_stop
#define tusbdDriverOpenEp               dwc2_device_openep
#define tusbdDriverCloseEp              dwc2_device_closeep
#define tusbdDriverFlushEp              dwc2_device_flushep
#define tusbdDriverStallEp              dwc2_device_stallep
#define tusbdDriverClearStallEp         dwc2_device_clearep
#define tusbdDriverStallConditionEp     dwc2_device_getstallcondition
#define tusbdDriverStartTransmit        dwc2_device_transmitdata
#define tusbdDriverSetupReceive         dwc2_device_startreceive
#define tusbdDriverTestMode             dwc2_device_testmode

#endif /* _TUSBD_CONF_H_ */

