/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2017 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: tusbd_request.c 698 2017-10-06 21:56:09Z roi $
 */
/*
 *  USB Device Middleware REQUEST
 */

#include "tusbd_base.h"


/*
 *  USB DEVICE ȥ̿ 
 *  parameter1 pdevice:  USB DEVICEϥɥ
 *  parameter2 pbuf:     Хåե
 *  parameter3 len:      ǡĹ
 *  return     TUSBD_ERCODE
 */
TUSBD_ERCODE
tusbdControlSendData(TUSBD_Handle_t *pdevice, uint8_t *pbuf, uint16_t len)
{
	pdevice->ep0_state          = TUSBD_EP0_DATAIN;
	pdevice->ep_in[0].xfersize  = len;
	pdevice->ep_in[0].remlength = len;
	return tusbdDriverStartTransmit(pdevice, 0x00, pbuf, len);
}

/*
 *  USB DEVICE ȥ̿ 
 *  parameter1 pdevice:  USB DEVICEϥɥ
 *  parameter2 pbuf:     Хåե
 *  parameter3 len:      ǡĹ
 *  return     TUSBD_ERCODE
 */
TUSBD_ERCODE
tusbdControlReceiveStart(TUSBD_Handle_t *pdevice, uint8_t *pbuf, uint16_t len)
{
	pdevice->ep0_state = TUSBD_EP0_DATAOUT; 
	pdevice->ep_out[0].xfersize  = len;
	pdevice->ep_out[0].remlength = len;
	return tusbdDriverSetupReceive(pdevice, 0, pbuf, len);
}

/*
 *  USB DEVICE ȥ̿ ơ
 *  parameter1 pdevice:  USB DEVICEϥɥ
 *  return     TUSBD_ERCODE
 */
TUSBD_ERCODE
tusbdControlSendStatus(TUSBD_Handle_t *pdevice)
{
	pdevice->ep0_state = TUSBD_EP0_STATUSIN;
	return tusbdDriverStartTransmit(pdevice, 0x00, NULL, 0);
}

/*
 *  USB DEVICE ȥ̿ ơ
 *  parameter1 pdevice:  USB DEVICEϥɥ
 *  return     TUSBD_ERCODE
 */
TUSBD_ERCODE
tusbdControlReceiveStatus(TUSBD_Handle_t *pdevice)
{
	pdevice->ep0_state = TUSBD_EP0_STATUSOUT;
	return tusbdDriverSetupReceive(pdevice, 0, NULL, 0);
}

/*
 *  USB DEVICE ȥ̿ STALL
 *  parameter1 pdevice:  USB DEVICEϥɥ
 *  parameter2 req:      åȥåץꥯ
 *  return     TUSBD_ERCODE
 */

void
tusbdControlSendStall(TUSBD_Handle_t *pdevice, UsbSetupRequest *req)
{
	pdevice->ep0_state = TUSBD_EP0_IDLE;
	tusbdDriverStallEp(pdevice, req->bmRequest & 0x80);
}


