/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2017 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: tusbh_prt.h 698 2017-09-21 10:12:27Z roi $
 */
/*
 *  USB Host Middleware PRT
 */

#ifndef _HUSBH_PRT_H_
#define _HUSBH_PRT_H_

#include "tusbh_base.h"

#ifdef __cplusplus
 extern "C" {
#endif


#define PRT_VERNDER_REQUEST_EOJ     0
#define PRT_REQUEST_DEVICEID        0
#define PRT_REQUEST_PORTSTATUS      1
#define PRT_REQUEST_SOFTRESET       2

#define PRT_REQUEST_STATUS_TYPE         (USB_DEVICE_TO_HOST | USB_REQUEST_TYPE_CLASS | USB_RECIPIENT_INTERFACE)
#define PRT_VENDER_SEND_TYPE            (USB_HOST_TO_DEVICE | USB_REQUEST_TYPE_VENDOR | USB_RECIPIENT_INTERFACE)

/*
 *  PRTХå
 */
#define PRT_LINE_STATUS_CHANGED         1
#define PRT_LINE_STATUS_SENDED          2
#define PRT_LINE_STATUS_RECEIVED        3

/*
 *  PRTץξ
 */
enum
{
	PRT_PROCESS_INIT = 0,
	PRT_PROCESS_IDLE,
	PRT_PROCESS_CONTROL,
	PRT_PROCESS_CONTROL_WAIT,
	PRT_PROCESS_SEND,
	PRT_PROCESS_RECEIVE,
	PRT_PROCESS_TRANSFER_WAIT,
	PRT_PROCESS_ERROR,
	PRT_PROCESS_ERROR_WAIT
};

/*
 *  PRTϥɥ
 */
typedef struct
{
	TUSBH_Device_t            *pDev;
	uint8_t                   state;
	uint8_t                   pre_state;
	uint8_t                   cmd;
	uint8_t                   dummy;
	uint16_t                  TrnEpSize;
	uint16_t                  TrnPktSize;

	uint8_t                   InPipe;
	uint8_t                   OutPipe;
	uint8_t                   OutEp;
	uint8_t                   InEp;
	uint16_t                  OutEpSize;
	uint16_t                  InEpSize;
	uint8_t                   controlType;
	uint8_t                   controlRequest;
	uint16_t                  controlLength;
	uint32_t                  TrnLength;
	uint32_t                  TrnSize;
	uint8_t                   *pTrnBuff;
	uint32_t                  timer;
	uint32_t                  urb_wait;
	ID                        rw_taskid;
	uint32_t                  rw_status;
	uint8_t                   buffer[64];
} PRT_Handle_t;


void         tusbhLinkPRT(TUSBH_Handle_t *phost);
TUSBH_ERCODE tusbhPrtEOJ(TUSBH_Handle_t *phost, uint8_t unit, uint8_t cmd, uint8_t prm1, uint8_t prm2);
TUSBH_ERCODE tusbhPrtPortID(TUSBH_Handle_t *phost, uint8_t unit, uint8_t *buf);
TUSBH_ERCODE tusbhPrtSend(TUSBH_Handle_t *phost, uint8_t unit, uint8_t *pbuf, uint32_t length);
TUSBH_ERCODE tusbhPrtReceive(TUSBH_Handle_t *phost, uint8_t unit, uint8_t *pbuf, uint32_t *length, uint32_t timeout);
void tusbhSetPrtCallBack(TUSBH_Handle_t *phost, void (*func)(TUSBH_Device_t *p, uint8_t));


#ifdef __cplusplus
}
#endif

#endif /* _HUSBH_PRT_H_ */

